// RegisterUebersichtDlg.cpp: Implementierungsdatei
//

#include "stdafx.h"
#include "DesfireTest.h"
#include "RegisterUebersichtDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// Dialogfeld CRegisterUebersichtDlg 

CRegisterUebersichtDlg::CRegisterUebersichtDlg()
	: CDialog()
{
	//{{AFX_DATA_INIT(CRegisterUebersichtDlg)
		// HINWEIS: Der Klassen-Assistent fgt hier Elementinitialisierung ein
	//}}AFX_DATA_INIT
  m_hPort = 0;
}

void CRegisterUebersichtDlg::FuelleListe()
{
  BYTE val;
  CString strNr,strHex,strDez,strBinaer;
  if (!m_hPort)
  {
    return;
  }

  int ItemNr = 0;
  for (int i = 0; i < 64; i++)
  {
    Sleep(1);

    if (m_Liste.GetItemCount() > i)
    {
      m_Liste.SetItemText(i,0,"");
      m_Liste.SetItemText(i,1,"");
      m_Liste.SetItemText(i,2,"");
      m_Liste.SetItemText(i,3,"");
    }
    if (TSHRW_ReadRegister(m_hPort,i,&val) > 0)
    {
      strNr.Format("%02XH (%2d)",i,i);
      strHex.Format("%02X",val);
      strDez.Format("%d",val);
      Bin2String(strBinaer,&val,1);

      if (m_Liste.GetItemCount() > i)
      {
        ItemNr = i;
        m_Liste.SetItemText(ItemNr,0,strNr);
      }
      else
      {
        ItemNr = m_Liste.InsertItem(ItemNr,strNr);
      }
      m_Liste.SetItemText(ItemNr,1,strHex);
      m_Liste.SetItemText(ItemNr,2,strDez);
      m_Liste.SetItemText(ItemNr,3,strBinaer);

      ItemNr++;
    }
  }
}

void CRegisterUebersichtDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CRegisterUebersichtDlg)
	DDX_Control(pDX, IDC_LISTE, m_Liste);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CRegisterUebersichtDlg, CDialog)
	//{{AFX_MSG_MAP(CRegisterUebersichtDlg)
	ON_BN_CLICKED(IDC_LESEN, OnLesen)
	ON_BN_CLICKED(IDC_SPEICHERN, OnSpeichern)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// Behandlungsroutinen fr Nachrichten CRegisterUebersichtDlg 

void CRegisterUebersichtDlg::OnCancel() 
{
	// TODO: Zustzlichen Bereinigungscode hier einfgen
	
	CDialog::OnCancel();
}

void CRegisterUebersichtDlg::OnLesen() 
{
  CWaitCursor wait;
  GetDlgItem(IDC_LESEN)->EnableWindow(FALSE);
  FuelleListe();
  GetDlgItem(IDC_LESEN)->EnableWindow(TRUE);
  GetDlgItem(IDC_LESEN)->SetFocus();
}

BOOL CRegisterUebersichtDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
  m_Liste.SetExtendedStyle(LVS_EX_GRIDLINES|LVS_EX_FULLROWSELECT);
	m_Liste.InsertColumn(0,"Reg #",LVCFMT_LEFT,50,0);
	m_Liste.InsertColumn(1,"Hex",LVCFMT_CENTER,40,1);
	m_Liste.InsertColumn(2,"Dez",LVCFMT_RIGHT,40,2);
	m_Liste.InsertColumn(3,"Binr",LVCFMT_CENTER,60,3);

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX-Eigenschaftenseiten sollten FALSE zurckgeben
}

void CRegisterUebersichtDlg::OnSpeichern() 
{
	CStdioFile File;

  char ExeName[_MAX_PATH];
  ::GetModuleFileName(NULL,ExeName,_MAX_PATH);
  CString Filename = ExeName;
  Filename = Filename.Left(Filename.ReverseFind('\\'));
  Filename += "\\RegisterInhalt.txt";

  if (!File.Open(Filename,CFile::modeReadWrite|CFile::modeCreate|CFile::typeText))
  {
    AfxMessageBox("Datei konnte nicht geffnet werden");
    return;
  }

  CString Line;

  Line = "";
	Line += "Reg #   ";
  Line += "\t";
  Line += "Hex";
  Line += "\t";
  Line += "Dez";
  Line += "\t";
  Line += "Binr";
  Line += "\n";

  File.WriteString(Line);

  for (int i = 0; i < m_Liste.GetItemCount(); i++)
  {
    Line = "";
    Line += m_Liste.GetItemText(i,0);
    Line += "\t";
    Line += m_Liste.GetItemText(i,1);
    Line += "\t";
    Line += m_Liste.GetItemText(i,2);
    Line += "\t";
    Line += m_Liste.GetItemText(i,3);
    Line += "\n";
    File.WriteString(Line);
  }

  File.Close();

}
